vim.fn.sign_define("LspDiagnosticsSignError",
        {text = "󰅙 ", texthl = "LspDiagnosticsSignError"})
vim.fn.sign_define("LspDiagnosticsSignWarning",
        {text = "󱇎 ", texthl = "LspDiagnosticsSignWarning"})
vim.fn.sign_define("LspDiagnosticsSignInformation",
        {text = "󰰄 ", texthl = "LspDiagnosticsSignInformation"})
vim.fn.sign_define("LspDiagnosticsSignHint",
        {text = "󰐗 ", texthl = "LspDiagnosticsSignHint"})

require("neo-tree").setup({
  close_if_last_window = false,
  popup_border_style = "rounded",
  enable_git_status = true,
  enable_diagnostics = true,
  open_files_do_not_replace_types = { "terminal", "trouble", "qf" },
  sort_case_insensitive = false,
  sort_function = nil ,
  default_component_configs = {
    indent = {
      with_expanders = true,
    },
    icon = {
      folder_closed = "󰉋",
      folder_open = "󰝰",
      folder_empty = "󰉖",
      default = "*",
      highlight = "NeoTreeFileIcon"
    },
    modified = {
      symbol = "󰧞",
      highlight = "NeoTreeModified",
    },
    name = {
      trailing_slash = false,
      use_git_status_colors = true,
      highlight = "NeoTreeFileName",
    },
    git_status = {
      symbols = {
        added     = "󰜄",
        modified  = "󰑕",
        deleted   = "󰅗",
        renamed   = "󰛂",
        untracked = "󰞋",
        ignored   = "󰿠",
        unstaged  = "󰄱",
        staged    = "󰄵",
        conflict  = "",
      }
    },
  },
})
